unit schFacturasClienteClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_DarReferencia = '{CF24962F-7C64-47C6-805E-667250431457}';
  RID_FacturasCliente = '{463EEEC0-655F-4A12-83EE-CF674A0033F4}';
  RID_FacturasCliente_Detalles = '{BE7124DA-0D20-452B-A7B0-2B26AC5C7ABA}';
  RID_FacturasCliente_Refresh = '{03AF9E57-4A44-4C76-B74F-21F98B4E0A63}';

  { Data table names }
  nme_DarReferencia = 'DarReferencia';
  nme_FacturasCliente = 'FacturasCliente';
  nme_FacturasCliente_Detalles = 'FacturasCliente_Detalles';
  nme_FacturasCliente_Refresh = 'FacturasCliente_Refresh';

  { DarReferencia fields }
  fld_DarReferenciaVALOR = 'VALOR';

  { DarReferencia field indexes }
  idx_DarReferenciaVALOR = 0;

  { FacturasCliente fields }
  fld_FacturasClienteICONO = 'ICONO';
  fld_FacturasClienteID = 'ID';
  fld_FacturasClienteID_EMPRESA = 'ID_EMPRESA';
  fld_FacturasClienteID_CONTRATO = 'ID_CONTRATO';
  fld_FacturasClienteREFERENCIA = 'REFERENCIA';
  fld_FacturasClienteFECHA_FACTURA = 'FECHA_FACTURA';
  fld_FacturasClienteVENCIMIENTO = 'VENCIMIENTO';
  fld_FacturasClienteSITUACION = 'SITUACION';
  fld_FacturasClienteBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_FacturasClienteDESCUENTO = 'DESCUENTO';
  fld_FacturasClienteIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_FacturasClienteIVA = 'IVA';
  fld_FacturasClienteIMPORTE_IVA = 'IMPORTE_IVA';
  fld_FacturasClienteIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasClienteOBSERVACIONES = 'OBSERVACIONES';
  fld_FacturasClienteFORMA_PAGO = 'FORMA_PAGO';
  fld_FacturasClienteID_CLIENTE = 'ID_CLIENTE';
  fld_FacturasClienteNIF_CIF = 'NIF_CIF';
  fld_FacturasClienteNOMBRE = 'NOMBRE';
  fld_FacturasClienteCALLE = 'CALLE';
  fld_FacturasClientePOBLACION = 'POBLACION';
  fld_FacturasClientePROVINCIA = 'PROVINCIA';
  fld_FacturasClienteCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_FacturasClienteFECHA_ALTA = 'FECHA_ALTA';
  fld_FacturasClienteFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_FacturasClienteUSUARIO = 'USUARIO';
  fld_FacturasClienteFECHA_PAGADO = 'FECHA_PAGADO';
  fld_FacturasClienteFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';

  { FacturasCliente field indexes }
  idx_FacturasClienteICONO = 0;
  idx_FacturasClienteID = 1;
  idx_FacturasClienteID_EMPRESA = 2;
  idx_FacturasClienteID_CONTRATO = 3;
  idx_FacturasClienteREFERENCIA = 4;
  idx_FacturasClienteFECHA_FACTURA = 5;
  idx_FacturasClienteVENCIMIENTO = 6;
  idx_FacturasClienteSITUACION = 7;
  idx_FacturasClienteBASE_IMPONIBLE = 8;
  idx_FacturasClienteDESCUENTO = 9;
  idx_FacturasClienteIMPORTE_DESCUENTO = 10;
  idx_FacturasClienteIVA = 11;
  idx_FacturasClienteIMPORTE_IVA = 12;
  idx_FacturasClienteIMPORTE_TOTAL = 13;
  idx_FacturasClienteOBSERVACIONES = 14;
  idx_FacturasClienteFORMA_PAGO = 15;
  idx_FacturasClienteID_CLIENTE = 16;
  idx_FacturasClienteNIF_CIF = 17;
  idx_FacturasClienteNOMBRE = 18;
  idx_FacturasClienteCALLE = 19;
  idx_FacturasClientePOBLACION = 20;
  idx_FacturasClientePROVINCIA = 21;
  idx_FacturasClienteCODIGO_POSTAL = 22;
  idx_FacturasClienteFECHA_ALTA = 23;
  idx_FacturasClienteFECHA_MODIFICACION = 24;
  idx_FacturasClienteUSUARIO = 25;
  idx_FacturasClienteFECHA_PAGADO = 26;
  idx_FacturasClienteFECHA_VENCIMIENTO = 27;

  { FacturasCliente_Detalles fields }
  fld_FacturasCliente_DetallesID = 'ID';
  fld_FacturasCliente_DetallesID_FACTURA = 'ID_FACTURA';
  fld_FacturasCliente_DetallesPOSICION = 'POSICION';
  fld_FacturasCliente_DetallesTIPO_DETALLE = 'TIPO_DETALLE';
  fld_FacturasCliente_DetallesCONCEPTO = 'CONCEPTO';
  fld_FacturasCliente_DetallesCANTIDAD = 'CANTIDAD';
  fld_FacturasCliente_DetallesIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_FacturasCliente_DetallesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasCliente_DetallesVISIBLE = 'VISIBLE';

  { FacturasCliente_Detalles field indexes }
  idx_FacturasCliente_DetallesID = 0;
  idx_FacturasCliente_DetallesID_FACTURA = 1;
  idx_FacturasCliente_DetallesPOSICION = 2;
  idx_FacturasCliente_DetallesTIPO_DETALLE = 3;
  idx_FacturasCliente_DetallesCONCEPTO = 4;
  idx_FacturasCliente_DetallesCANTIDAD = 5;
  idx_FacturasCliente_DetallesIMPORTE_UNIDAD = 6;
  idx_FacturasCliente_DetallesIMPORTE_TOTAL = 7;
  idx_FacturasCliente_DetallesVISIBLE = 8;

  { FacturasCliente_Refresh fields }
  fld_FacturasCliente_RefreshICONO = 'ICONO';
  fld_FacturasCliente_RefreshID = 'ID';
  fld_FacturasCliente_RefreshID_EMPRESA = 'ID_EMPRESA';
  fld_FacturasCliente_RefreshID_CONTRATO = 'ID_CONTRATO';
  fld_FacturasCliente_RefreshUSUARIO = 'USUARIO';
  fld_FacturasCliente_RefreshFECHA_FACTURA = 'FECHA_FACTURA';
  fld_FacturasCliente_RefreshVENCIMIENTO = 'VENCIMIENTO';
  fld_FacturasCliente_RefreshSITUACION = 'SITUACION';
  fld_FacturasCliente_RefreshBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_FacturasCliente_RefreshREFERENCIA = 'REFERENCIA';
  fld_FacturasCliente_RefreshIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_FacturasCliente_RefreshIVA = 'IVA';
  fld_FacturasCliente_RefreshDESCUENTO = 'DESCUENTO';
  fld_FacturasCliente_RefreshIMPORTE_IVA = 'IMPORTE_IVA';
  fld_FacturasCliente_RefreshIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_FacturasCliente_RefreshFORMA_PAGO = 'FORMA_PAGO';
  fld_FacturasCliente_RefreshID_CLIENTE = 'ID_CLIENTE';
  fld_FacturasCliente_RefreshNIF_CIF = 'NIF_CIF';
  fld_FacturasCliente_RefreshOBSERVACIONES = 'OBSERVACIONES';
  fld_FacturasCliente_RefreshNOMBRE = 'NOMBRE';
  fld_FacturasCliente_RefreshCALLE = 'CALLE';
  fld_FacturasCliente_RefreshPROVINCIA = 'PROVINCIA';
  fld_FacturasCliente_RefreshCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_FacturasCliente_RefreshFECHA_ALTA = 'FECHA_ALTA';
  fld_FacturasCliente_RefreshFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_FacturasCliente_RefreshPOBLACION = 'POBLACION';
  fld_FacturasCliente_RefreshFECHA_PAGADO = 'FECHA_PAGADO';
  fld_FacturasCliente_RefreshFECHA_VENCIMIENTO = 'FECHA_VENCIMIENTO';

  { FacturasCliente_Refresh field indexes }
  idx_FacturasCliente_RefreshICONO = 0;
  idx_FacturasCliente_RefreshID = 1;
  idx_FacturasCliente_RefreshID_EMPRESA = 2;
  idx_FacturasCliente_RefreshID_CONTRATO = 3;
  idx_FacturasCliente_RefreshUSUARIO = 4;
  idx_FacturasCliente_RefreshFECHA_FACTURA = 5;
  idx_FacturasCliente_RefreshVENCIMIENTO = 6;
  idx_FacturasCliente_RefreshSITUACION = 7;
  idx_FacturasCliente_RefreshBASE_IMPONIBLE = 8;
  idx_FacturasCliente_RefreshREFERENCIA = 9;
  idx_FacturasCliente_RefreshIMPORTE_DESCUENTO = 10;
  idx_FacturasCliente_RefreshIVA = 11;
  idx_FacturasCliente_RefreshDESCUENTO = 12;
  idx_FacturasCliente_RefreshIMPORTE_IVA = 13;
  idx_FacturasCliente_RefreshIMPORTE_TOTAL = 14;
  idx_FacturasCliente_RefreshFORMA_PAGO = 15;
  idx_FacturasCliente_RefreshID_CLIENTE = 16;
  idx_FacturasCliente_RefreshNIF_CIF = 17;
  idx_FacturasCliente_RefreshOBSERVACIONES = 18;
  idx_FacturasCliente_RefreshNOMBRE = 19;
  idx_FacturasCliente_RefreshCALLE = 20;
  idx_FacturasCliente_RefreshPROVINCIA = 21;
  idx_FacturasCliente_RefreshCODIGO_POSTAL = 22;
  idx_FacturasCliente_RefreshFECHA_ALTA = 23;
  idx_FacturasCliente_RefreshFECHA_MODIFICACION = 24;
  idx_FacturasCliente_RefreshPOBLACION = 25;
  idx_FacturasCliente_RefreshFECHA_PAGADO = 26;
  idx_FacturasCliente_RefreshFECHA_VENCIMIENTO = 27;

type
  { IDarReferencia }
  IDarReferencia = interface(IDAStronglyTypedDataTable)
  ['{1F204ECB-4153-4FF9-B31D-18C30C038504}']
    { Property getters and setters }
    function GetVALORValue: String;
    procedure SetVALORValue(const aValue: String);


    { Properties }
    property VALOR: String read GetVALORValue write SetVALORValue;
  end;

  { TDarReferenciaDataTableRules }
  TDarReferenciaDataTableRules = class(TDADataTableRules, IDarReferencia)
  private
  protected
    { Property getters and setters }
    function GetVALORValue: String; virtual;
    procedure SetVALORValue(const aValue: String); virtual;

    { Properties }
    property VALOR: String read GetVALORValue write SetVALORValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasCliente }
  IFacturasCliente = interface(IDAStronglyTypedDataTable)
  ['{B5FDAE8F-0998-4B22-A35D-DCA5B8403CAE}']
    { Property getters and setters }
    function GetICONOValue: Integer;
    procedure SetICONOValue(const aValue: Integer);
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_CONTRATOValue: Integer;
    procedure SetID_CONTRATOValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetVENCIMIENTOValue: Integer;
    procedure SetVENCIMIENTOValue(const aValue: Integer);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetBASE_IMPONIBLEValue: Float;
    procedure SetBASE_IMPONIBLEValue(const aValue: Float);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_DESCUENTOValue: Float;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Float);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIMPORTE_IVAValue: Float;
    procedure SetIMPORTE_IVAValue(const aValue: Float);
    function GetIMPORTE_TOTALValue: Float;
    procedure SetIMPORTE_TOTALValue(const aValue: Float);
    function GetOBSERVACIONESValue: IROStrings;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings);
    function GetFORMA_PAGOValue: IROStrings;
    procedure SetFORMA_PAGOValue(const aValue: IROStrings);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetFECHA_PAGADOValue: DateTime;
    procedure SetFECHA_PAGADOValue(const aValue: DateTime);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);


    { Properties }
    property ICONO: Integer read GetICONOValue write SetICONOValue;
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_CONTRATO: Integer read GetID_CONTRATOValue write SetID_CONTRATOValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property VENCIMIENTO: Integer read GetVENCIMIENTOValue write SetVENCIMIENTOValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Float read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Float read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Float read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property FORMA_PAGO: IROStrings read GetFORMA_PAGOValue write SetFORMA_PAGOValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property FECHA_PAGADO: DateTime read GetFECHA_PAGADOValue write SetFECHA_PAGADOValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
  end;

  { TFacturasClienteDataTableRules }
  TFacturasClienteDataTableRules = class(TDADataTableRules, IFacturasCliente)
  private
  protected
    { Property getters and setters }
    function GetICONOValue: Integer; virtual;
    procedure SetICONOValue(const aValue: Integer); virtual;
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_CONTRATOValue: Integer; virtual;
    procedure SetID_CONTRATOValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetVENCIMIENTOValue: Integer; virtual;
    procedure SetVENCIMIENTOValue(const aValue: Integer); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetBASE_IMPONIBLEValue: Float; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Float); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_DESCUENTOValue: Float; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Float); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIMPORTE_IVAValue: Float; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Float); virtual;
    function GetIMPORTE_TOTALValue: Float; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Float); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetFORMA_PAGOValue: IROStrings; virtual;
    procedure SetFORMA_PAGOValue(const aValue: IROStrings); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetFECHA_PAGADOValue: DateTime; virtual;
    procedure SetFECHA_PAGADOValue(const aValue: DateTime); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;

    { Properties }
    property ICONO: Integer read GetICONOValue write SetICONOValue;
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_CONTRATO: Integer read GetID_CONTRATOValue write SetID_CONTRATOValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property VENCIMIENTO: Integer read GetVENCIMIENTOValue write SetVENCIMIENTOValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Float read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_DESCUENTO: Float read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IMPORTE_IVA: Float read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property FORMA_PAGO: IROStrings read GetFORMA_PAGOValue write SetFORMA_PAGOValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property FECHA_PAGADO: DateTime read GetFECHA_PAGADOValue write SetFECHA_PAGADOValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasCliente_Detalles }
  IFacturasCliente_Detalles = interface(IDAStronglyTypedDataTable)
  ['{14377628-97FB-4912-96FE-0EA611EB0E4A}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetIMPORTE_UNIDADValue: Float;
    procedure SetIMPORTE_UNIDADValue(const aValue: Float);
    function GetIMPORTE_TOTALValue: Float;
    procedure SetIMPORTE_TOTALValue(const aValue: Float);
    function GetVISIBLEValue: Integer;
    procedure SetVISIBLEValue(const aValue: Integer);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Float read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
  end;

  { TFacturasCliente_DetallesDataTableRules }
  TFacturasCliente_DetallesDataTableRules = class(TDADataTableRules, IFacturasCliente_Detalles)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetIMPORTE_UNIDADValue: Float; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Float); virtual;
    function GetIMPORTE_TOTALValue: Float; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Float); virtual;
    function GetVISIBLEValue: Integer; virtual;
    procedure SetVISIBLEValue(const aValue: Integer); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property IMPORTE_UNIDAD: Float read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IFacturasCliente_Refresh }
  IFacturasCliente_Refresh = interface(IDAStronglyTypedDataTable)
  ['{9A51065B-F133-4F48-8FC2-C08E69839D7E}']
    { Property getters and setters }
    function GetICONOValue: Integer;
    procedure SetICONOValue(const aValue: Integer);
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_CONTRATOValue: Integer;
    procedure SetID_CONTRATOValue(const aValue: Integer);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetVENCIMIENTOValue: Integer;
    procedure SetVENCIMIENTOValue(const aValue: Integer);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetBASE_IMPONIBLEValue: Float;
    procedure SetBASE_IMPONIBLEValue(const aValue: Float);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetIMPORTE_DESCUENTOValue: Float;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Float);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetIMPORTE_IVAValue: Float;
    procedure SetIMPORTE_IVAValue(const aValue: Float);
    function GetIMPORTE_TOTALValue: Float;
    procedure SetIMPORTE_TOTALValue(const aValue: Float);
    function GetFORMA_PAGOValue: IROStrings;
    procedure SetFORMA_PAGOValue(const aValue: IROStrings);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetOBSERVACIONESValue: IROStrings;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetFECHA_PAGADOValue: DateTime;
    procedure SetFECHA_PAGADOValue(const aValue: DateTime);
    function GetFECHA_VENCIMIENTOValue: DateTime;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime);


    { Properties }
    property ICONO: Integer read GetICONOValue write SetICONOValue;
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_CONTRATO: Integer read GetID_CONTRATOValue write SetID_CONTRATOValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property VENCIMIENTO: Integer read GetVENCIMIENTOValue write SetVENCIMIENTOValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Float read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property IMPORTE_DESCUENTO: Float read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_IVA: Float read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property FORMA_PAGO: IROStrings read GetFORMA_PAGOValue write SetFORMA_PAGOValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property FECHA_PAGADO: DateTime read GetFECHA_PAGADOValue write SetFECHA_PAGADOValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;
  end;

  { TFacturasCliente_RefreshDataTableRules }
  TFacturasCliente_RefreshDataTableRules = class(TDADataTableRules, IFacturasCliente_Refresh)
  private
  protected
    { Property getters and setters }
    function GetICONOValue: Integer; virtual;
    procedure SetICONOValue(const aValue: Integer); virtual;
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_CONTRATOValue: Integer; virtual;
    procedure SetID_CONTRATOValue(const aValue: Integer); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetVENCIMIENTOValue: Integer; virtual;
    procedure SetVENCIMIENTOValue(const aValue: Integer); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetBASE_IMPONIBLEValue: Float; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Float); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetIMPORTE_DESCUENTOValue: Float; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Float); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetIMPORTE_IVAValue: Float; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Float); virtual;
    function GetIMPORTE_TOTALValue: Float; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Float); virtual;
    function GetFORMA_PAGOValue: IROStrings; virtual;
    procedure SetFORMA_PAGOValue(const aValue: IROStrings); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    procedure SetOBSERVACIONESValue(const aValue: IROStrings); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetFECHA_PAGADOValue: DateTime; virtual;
    procedure SetFECHA_PAGADOValue(const aValue: DateTime); virtual;
    function GetFECHA_VENCIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_VENCIMIENTOValue(const aValue: DateTime); virtual;

    { Properties }
    property ICONO: Integer read GetICONOValue write SetICONOValue;
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_CONTRATO: Integer read GetID_CONTRATOValue write SetID_CONTRATOValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property VENCIMIENTO: Integer read GetVENCIMIENTOValue write SetVENCIMIENTOValue;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property BASE_IMPONIBLE: Float read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property IMPORTE_DESCUENTO: Float read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property IMPORTE_IVA: Float read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_TOTAL: Float read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property FORMA_PAGO: IROStrings read GetFORMA_PAGOValue write SetFORMA_PAGOValue;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue write SetOBSERVACIONESValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property FECHA_PAGADO: DateTime read GetFECHA_PAGADOValue write SetFECHA_PAGADOValue;
    property FECHA_VENCIMIENTO: DateTime read GetFECHA_VENCIMIENTOValue write SetFECHA_VENCIMIENTOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TDarReferenciaDataTableRules }
constructor TDarReferenciaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TDarReferenciaDataTableRules.Destroy;
begin
  inherited;
end;

function TDarReferenciaDataTableRules.GetVALORValue: String;
begin
  result := DataTable.Fields[idx_DarReferenciaVALOR].AsString;
end;

procedure TDarReferenciaDataTableRules.SetVALORValue(const aValue: String);
begin
  DataTable.Fields[idx_DarReferenciaVALOR].AsString := aValue;
end;


{ TFacturasClienteDataTableRules }
constructor TFacturasClienteDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasClienteDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasClienteDataTableRules.GetICONOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteICONO].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetICONOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteICONO].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_EMPRESA].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_EMPRESA].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetID_CONTRATOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_CONTRATO].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_CONTRATOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_CONTRATO].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteREFERENCIA].AsString;
end;

procedure TFacturasClienteDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteREFERENCIA].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_FACTURA].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetVENCIMIENTOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteVENCIMIENTO].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetVENCIMIENTOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteVENCIMIENTO].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteSITUACION].AsString;
end;

procedure TFacturasClienteDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteSITUACION].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetBASE_IMPONIBLEValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteBASE_IMPONIBLE].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteBASE_IMPONIBLE].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteDESCUENTO].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteDESCUENTO].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_DESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_DESCUENTO].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_DESCUENTO].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteIVA].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteIVA].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_IVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_IVA].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_IVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_IVA].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetIMPORTE_TOTALValue: Float;
begin
  result := DataTable.Fields[idx_FacturasClienteIMPORTE_TOTAL].AsFloat;
end;

procedure TFacturasClienteDataTableRules.SetIMPORTE_TOTALValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasClienteIMPORTE_TOTAL].AsFloat := aValue;
end;

function TFacturasClienteDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_FacturasClienteOBSERVACIONES].AsString;
end;

procedure TFacturasClienteDataTableRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_FacturasClienteOBSERVACIONES].AsString := aValue.Text;
end;

function TFacturasClienteDataTableRules.GetFORMA_PAGOValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_FacturasClienteFORMA_PAGO].AsString;
end;

procedure TFacturasClienteDataTableRules.SetFORMA_PAGOValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_FacturasClienteFORMA_PAGO].AsString := aValue.Text;
end;

function TFacturasClienteDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasClienteID_CLIENTE].AsInteger;
end;

procedure TFacturasClienteDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasClienteID_CLIENTE].AsInteger := aValue;
end;

function TFacturasClienteDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteNIF_CIF].AsString;
end;

procedure TFacturasClienteDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteNIF_CIF].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteNOMBRE].AsString;
end;

procedure TFacturasClienteDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteNOMBRE].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteCALLE].AsString;
end;

procedure TFacturasClienteDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteCALLE].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasClientePOBLACION].AsString;
end;

procedure TFacturasClienteDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClientePOBLACION].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasClientePROVINCIA].AsString;
end;

procedure TFacturasClienteDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClientePROVINCIA].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteCODIGO_POSTAL].AsString;
end;

procedure TFacturasClienteDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteCODIGO_POSTAL].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_ALTA].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_FacturasClienteUSUARIO].AsString;
end;

procedure TFacturasClienteDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasClienteUSUARIO].AsString := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_PAGADOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_PAGADO].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_PAGADOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_PAGADO].AsDateTime := aValue;
end;

function TFacturasClienteDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasClienteFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TFacturasClienteDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasClienteFECHA_VENCIMIENTO].AsDateTime := aValue;
end;


{ TFacturasCliente_DetallesDataTableRules }
constructor TFacturasCliente_DetallesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasCliente_DetallesDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasCliente_DetallesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesID].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesID_FACTURA].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesID_FACTURA].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesPOSICION].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesPOSICION].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesTIPO_DETALLE].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesTIPO_DETALLE].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesCONCEPTO].AsString;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesCONCEPTO].AsString := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesCANTIDAD].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesCANTIDAD].AsInteger := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_UNIDADValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_UNIDAD].AsFloat;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_UNIDAD].AsFloat := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetIMPORTE_TOTALValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_TOTAL].AsFloat;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesIMPORTE_TOTAL].AsFloat := aValue;
end;

function TFacturasCliente_DetallesDataTableRules.GetVISIBLEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_DetallesVISIBLE].AsInteger;
end;

procedure TFacturasCliente_DetallesDataTableRules.SetVISIBLEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_DetallesVISIBLE].AsInteger := aValue;
end;


{ TFacturasCliente_RefreshDataTableRules }
constructor TFacturasCliente_RefreshDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TFacturasCliente_RefreshDataTableRules.Destroy;
begin
  inherited;
end;

function TFacturasCliente_RefreshDataTableRules.GetICONOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshICONO].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetICONOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshICONO].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_EMPRESA].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_EMPRESA].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_CONTRATOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_CONTRATO].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_CONTRATOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_CONTRATO].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshUSUARIO].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshUSUARIO].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_FACTURA].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetVENCIMIENTOValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshVENCIMIENTO].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetVENCIMIENTOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshVENCIMIENTO].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshSITUACION].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshSITUACION].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetBASE_IMPONIBLEValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshBASE_IMPONIBLE].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshBASE_IMPONIBLE].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshREFERENCIA].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshREFERENCIA].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_DESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_DESCUENTO].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_DESCUENTO].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIVA].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIVA].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshDESCUENTO].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshDESCUENTO].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_IVAValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_IVA].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_IVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_IVA].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetIMPORTE_TOTALValue: Float;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_TOTAL].AsFloat;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetIMPORTE_TOTALValue(const aValue: Float);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshIMPORTE_TOTAL].AsFloat := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFORMA_PAGOValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_FacturasCliente_RefreshFORMA_PAGO].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFORMA_PAGOValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFORMA_PAGO].AsString := aValue.Text;
end;

function TFacturasCliente_RefreshDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshID_CLIENTE].AsInteger;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshID_CLIENTE].AsInteger := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshNIF_CIF].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshNIF_CIF].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := NewROStrings();
  result.Text := DataTable.Fields[idx_FacturasCliente_RefreshOBSERVACIONES].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetOBSERVACIONESValue(const aValue: IROStrings);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshOBSERVACIONES].AsString := aValue.Text;
end;

function TFacturasCliente_RefreshDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshNOMBRE].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshNOMBRE].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshCALLE].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshCALLE].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshPROVINCIA].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshPROVINCIA].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshCODIGO_POSTAL].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshCODIGO_POSTAL].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_ALTA].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshPOBLACION].AsString;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshPOBLACION].AsString := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_PAGADOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_PAGADO].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_PAGADOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_PAGADO].AsDateTime := aValue;
end;

function TFacturasCliente_RefreshDataTableRules.GetFECHA_VENCIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_FacturasCliente_RefreshFECHA_VENCIMIENTO].AsDateTime;
end;

procedure TFacturasCliente_RefreshDataTableRules.SetFECHA_VENCIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_FacturasCliente_RefreshFECHA_VENCIMIENTO].AsDateTime := aValue;
end;


initialization
  RegisterDataTableRules(RID_DarReferencia, TDarReferenciaDataTableRules);
  RegisterDataTableRules(RID_FacturasCliente, TFacturasClienteDataTableRules);
  RegisterDataTableRules(RID_FacturasCliente_Detalles, TFacturasCliente_DetallesDataTableRules);
  RegisterDataTableRules(RID_FacturasCliente_Refresh, TFacturasCliente_RefreshDataTableRules);

end.
